--[[
	Version: 0.0.5
	Based Code provided by oUF_Freeb	
--]]
------------------ configuration --------------------
local hideinraid = true			-- hide party frames in raid
local onlypartyicons = false

local sett1ngs = config_file;
local _, class = UnitClass('player')

----------------- hide party -----------------------
if (sett1ngs.hideparty == true) then
	for i=1,4 do
		local party = "PartyMemberFrame"..i
		local frame = _G[party]

		frame:UnregisterAllEvents()
		frame.Show = dummy
		frame:Hide()

		_G[party..'HealthBar']:UnregisterAllEvents()
		_G[party..'ManaBar']:UnregisterAllEvents()
	end
end
--[[
if(hideinraid == true) then
    local partyToggle = CreateFrame("Frame")
    partyToggle:RegisterEvent("PLAYER_LOGIN")
    partyToggle:RegisterEvent("RAID_ROSTER_UPDATE")
    partyToggle:RegisterEvent("PARTY_LEADER_CHANGED")
    partyToggle:RegisterEvent("PARTY_MEMBERS_CHANGED")
    partyToggle:SetScript("OnEvent", function(self)
        if(InCombatLockdown()) then
            self:RegisterEvent("PLAYER_REGEN_ENABLED")
        else
            self:UnregisterEvent("PLAYER_REGEN_ENABLED")
            if(GetNumRaidMembers() > 0) then
                party:Hide()
            else
                party:Show()
            end
        end
    end)
end
--]]
local FormatTime = function(s)
	local day, hour, minute = 86400, 3600, 60
	if s >= day then
		return format("%dd", floor(s/day + 0.5)), s % day
	elseif s >= hour then
		return format("%dh", floor(s/hour + 0.5)), s % hour
	elseif s >= minute then
		if s <= minute * 5 then
			return format('%d:%02d', floor(s/60), s % minute), s - floor(s)
		end
		return format("%dm", floor(s/minute + 0.5)), s % minute
	elseif s >= minute / 12 then
		return floor(s + 0.5), (s * 100 - floor(s * 100))/100
	end
	return format("%.1f", s), (s * 100 - floor(s * 100))/100
end

local SetBD = function(parent, backdrop, color, strata)
	local bd = CreateFrame("Frame", nil, parent)
	bd:SetPoint("TOPLEFT", parent , "TOPLEFT", -1, 1)
	bd:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT", 1, -1)
	local s = strata or "background"
	bd:SetFrameStrata(s)
	bd:SetFrameLevel(parent:GetFrameLevel())
	bd:SetBackdrop(backdrop)
	local c = color or {0,0,0};
	bd:SetBackdropColor(unpack(c))
	bd:SetBackdropBorderColor(0, 0, 0)
	return bd
end

------ [Create aura timer, credits to Monolit]
local CreateAuraTimer = function(self,elapsed)
	if self.timeLeft then
		self.elapsed = (self.elapsed or 0) + elapsed
		if self.elapsed >= 0.1 then
			if not self.first then
				self.timeLeft = self.timeLeft - self.elapsed
			else
				self.timeLeft = self.timeLeft - GetTime()
				self.first = false
			end
			if self.timeLeft > 0 then
				local time = FormatTime(self.timeLeft)
				self.remaining:SetText(time)
				if self.timeLeft < 5 then
					self.remaining:SetTextColor(1, 0, 0)
				else
					self.remaining:SetTextColor(0.84, 0.75, 0.65)
				end
			else
				self.remaining:Hide()
				self:SetScript("OnUpdate", nil)
			end
			self.elapsed = 0
		end
	end
end
local CreateEnchantTimer = function(self, icons)
	for i = 1, 2 do
		local icon = icons[i]
		if icon.expTime then
			icon.timeLeft = icon.expTime - GetTime()
			icon.remaining:Show()
		else
			icon.remaining:Hide()
		end
		icon:SetScript("OnUpdate", CreateAuraTimer)
	end
end

if( sett1ngs.auto_scale == true ) then
	local sfix = CreateFrame("Frame")
	sfix:RegisterEvent("PLAYER_LOGIN")
	sfix:SetScript("OnEvent", function()
		SetCVar("useUiScale", 1)
		SetCVar("uiScale", 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))
	end)
end

local StyleTempEnchants = true -- Temp Enchants timer      
      BuffFrame:Hide() 

RuneFrame:Hide()

local backdrop = {
	bgFile = sett1ngs.texture,
	edgeFile = sett1ngs.glowtex, edgeSize = 1,
	insets = {top = 0, left = 0, bottom = 0, right = 0},
    }

local colors = setmetatable({
	power = setmetatable({
		['MANA'] = {0.14,0.35,1},
		['RAGE'] = {0.89,0.07,0.19},
		['FOCUS'] = {.71,.43,.27},
		['ENERGY'] = {1.0,0.96,0.41},
	}, {__index = oUF.colors.power}),
}, {__index = oUF.colors})


local function updateCombo(self, event, unit)
	if(unit == PlayerFrame.unit and unit ~= self.CPoints.unit) then
		self.CPoints.unit = unit
	end
end

-- Druid Power Credits to P3lim
local function UpdateDruidPower(self)
	local bar = self.DruidPower
	local num, str = UnitPowerType('player')
	local min = UnitPower('player', (num ~= 0) and 0 or 3)
	local max = UnitPowerMax('player', (num ~= 0) and 0 or 3)

	bar:SetMinMaxValues(0, max)

	if(min ~= max) then
		bar:SetValue(min)
		bar:SetAlpha(1)

		if(num ~= 0) then
			bar:SetStatusBarColor(unpack(colors.power['MANA']))
			bar.Text:SetFormattedText('%d', min)
		else
			bar:SetStatusBarColor(unpack(colors.power['ENERGY']))
			bar.Text:SetText()
		end
	else
		bar:SetAlpha(0)
		bar.Text:SetText()
	end
end

local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- Shorten Values
local format = string.format
local ShortValue = function(val)
    if val >= 10000000 then 
        return format("%.1fm", val / 1000000) 
    elseif val >= 1000000 then
        return format("%.2fm", val / 1000000) 
    else
        return val
    end
end

local MakeFS = function(parent)
    local f = parent:CreateFontString(nil, "OVERLAY")
    f:SetFont(sett1ngs.font, sett1ngs.fontsize+2, "OUTLINE")
	return f
end

-- Icon
local updateRIcon = function(self, event)
	local index = GetRaidTargetIndex(self.unit)
	if(index) then
		self.RIcon:SetText(ICON_LIST[index].."22|t")
	else
		self.RIcon:SetText()
	end
end

------		Filters Start	------------ ty p3lim
local focusFilter = {
	[GetSpellInfo(66331)] = true, -- Impale (ToC Beasts)
	[GetSpellInfo(72408)] = true, -- Rune of Blood (ICC Saurfang)
	[GetSpellInfo(72120)] = true, -- Frostbite (Toravon)
	[GetSpellInfo(71204)] = true, -- Touch of Insignificance (ICC Lady Deathwhisper)
	[GetSpellInfo(72219)] = true, -- Gastric Bloat (ICC Festergut)
	[GetSpellInfo(71127)] = true, -- Mortal Wound (ICC Precious & Stinky)
}
local function focusdebuffFilter(icons, unit, icon, name, rank, texture, count, dtype, duration, expiration, caster)
	if(focusFilter[name]) then
		return true
	end
end

------		Style Aura		-------------
local auraIcon = function(auras, button)
	button.count:ClearAllPoints()
	button.count:SetPoint("BOTTOMRIGHT", 3, -3)
	button.count:SetJustifyH("RIGHT")
	button.count:SetFont(sett1ngs.font, sett1ngs.fontsize, "THINOUTLINE")
	button.count:SetTextColor(.8, .8, .8)
	
	auras.disableCooldown = true

	button.icon:SetTexCoord(.1, .9, .1, .9)
	button.bd = SetBD(button, backdrop, sett1ngs.bcolor);
	button.overlay:Hide()
	
	local remaining = button:CreateFontString(nil, "OVERLAY")
	remaining:SetPoint("CENTER", 1, 1)
	remaining:SetFont(sett1ngs.font, sett1ngs.fontsize, "THINOUTLINE")
	remaining:SetTextColor(.8, .8, .8)
	remaining:SetJustifyH('LEFT')
	button.remaining = remaining
end

local PostUpdateIcon
do
	local playerUnits = {
		player = true,
		pet = true,
		vehicle = true,
	}

	PostUpdateIcon = function(icons, unit, icon, index, offset)
		local name, _, _, _, dtype, duration, expirationTime, unitCaster = UnitAura(unit, index, icon.filter)
		
		local texture = icon.icon
		if unitCaster == "player" or unitCaster == "pet" or unitCaster == "vehicle" then
			icon.icon:SetDesaturated(false)
		else
			if icon.debuff then
				icon.icon:SetDesaturated(true)
			end
		end
		
		if duration and duration > 0 then
			icon.remaining:Show()
		else
			icon.remaining:Hide()
		end
		
		icon.duration = duration
		icon.timeLeft = expirationTime
		icon.first = true
		icon:SetScript("OnUpdate", CreateAuraTimer)
	end
end
-- Health Function
local updateHealth = function(Health, unit, min, max)
	if(max ~= 0) then
		r, g, b = oUF.ColorGradient(min/max, 1,0,0, 1,1,0.33, 0,1,0)
	end
	Health.value:SetFormattedText('%s| |cff%02x%02x%02x%d%%|r', ShortValue(min), r*255, g*255, b*255, (min/max)*100)
	if ( Health:GetParent():GetName() == "oUF_player" or Health:GetParent():GetName() == "oUF_target" ) then
		if ( min ~= max and min ~= (max-max)) then
			Health.sparkHP:SetPoint("CENTER", Health, "LEFT", (min / max) * sett1ngs.mX,0 )
			Health.sparkHP:Show()
		end
		if ( min == max or min == (max-max)) then
			Health.sparkHP:Hide()
		end
	elseif (unit == 'targettarget' or unit == 'focus') then
		if ( min ~= max and min ~= (max-max) ) then
			Health.sparkHP:SetPoint("CENTER", Health, "LEFT", (min / max) * sett1ngs.sX,0 )
			Health.sparkHP:Show()
		end
		if ( min == max or min == (max-max) ) then
			Health.sparkHP:Hide()
		end
	end	
end

--[[
local updateHealth = function(self, event, unit, bar, min, max)
	if(max ~= 0) then
		r, g, b = oUF.ColorGradient(min/max, 1,0,0, 1,1,0.33, 0,1,0)
	end
	if ( self:GetName() == "oUF_player" or self:GetName() == "oUF_target" ) then
		bar.value:SetFormattedText('%s| |cff%02x%02x%02x%d%%|r', ShortValue(min), r*255, g*255, b*255, (min/max)*100)
		if ( min ~= max and min ~= (max-max)) then
			self.Health.sparkHP:SetPoint("CENTER", self.Health, "LEFT", (min / max) * sett1ngs.mX,0 )
			self.Health.sparkHP:Show()
		end
		if ( min == max or min == (max-max)) then
			self.Health.sparkHP:Hide()
		end
		if(not UnitIsConnected(unit)) then
			bar:SetValue(0)
			bar.value:SetText('|cffD7BEA5'..'Offline')
		elseif(UnitIsDead(unit)) then
			bar:SetValue(0)
			bar.value:SetText('|cffD7BEA5'..'Dead')
		elseif(UnitIsGhost(unit)) then
			bar:SetValue(0)
			bar.value:SetText('|cffD7BEA5'..'Ghost')
		end
	elseif (unit == 'targettarget' or unit == 'focus') then
		if ( min ~= max and min ~= (max-max) ) then
			self.Health.sparkHP:SetPoint("CENTER", self.Health, "LEFT", (min / max) * sett1ngs.sX,0 )
			self.Health.sparkHP:Show()
		end
		if ( min == max or min == (max-max) ) then
			self.Health.sparkHP:Hide()
		end
	end	
end
--]]
-- Power Function
local updatePower = function(Power, unit, min, max)

--[[if ( unit == "player" or unit == "target" ) then
		if ( min ~= max and min ~= (max-max)) then
			self.Power.sparkHP:SetPoint("CENTER", pp, "LEFT", (min / max) * sett1ngs.mX,0 )
			self.Power.sparkHP:Show()
		end
		if ( min == max or min == (max-max)) then
			self.Power.sparkHP:Hide()
		end
	elseif (unit == 'targettarget' or unit == 'focus') then
		if ( min ~= max and min ~= (max-max) ) then
			self.Power.sparkHP:SetPoint("CENTER", pp, "LEFT", (min / max) * sett1ngs.sX,0 )
			self.Power.sparkHP:Show()
		end
		if ( min == max or min == (max-max) ) then
			self.Power.sparkHP:Hide()
		end
	end
--]]
	local health = Power:GetParent().Health
	if ( Power:GetParent():GetName() == "oUF_player" or Power:GetParent():GetName() == "oUF_target" or Power:GetParent():GetName() == "oUF_focus") then
		if(max ~= 0) then
			health:SetHeight(sett1ngs.mhp)
			Power:Show()
			if ( min == 0 or UnitIsDead(unit) or UnitIsGhost(unit) or not UnitIsConnected(unit)) then
				Power.value:SetText()
			else
				if (unit=="player") then
					Power.value:SetFormattedText('%s', ShortValue(min))
	 			elseif (unit == "target") then
  	     				Power.value:SetFormattedText('%s', ShortValue(min))
  	  			else
--	     				Power.value:SetFormattedText('%s|%s', ShortValue(max), ShortValue(min))	
  	     				Power.value:SetFormattedText('%s', ShortValue(min))
	  			end 
			end
		else
			health:SetHeight(sett1ngs.mhp+sett1ngs.mpower+1)
			Power:Hide()
		end
	elseif ( Power:GetParent():GetName() == "oUF_pet" or Power:GetParent():GetName() == "oUF_pettarget" or Power:GetParent():GetName() == "oUF_tot") then
		if(max ~= 0) then
			health:SetHeight(sett1ngs.shp)
			Power:Show()
			if ( min == 0 or UnitIsDead(unit) or UnitIsGhost(unit) or not UnitIsConnected(unit)) then
				Power.value:SetText()
			else
				if (unit=="player") then
					Power.value:SetFormattedText('%s', ShortValue(min))
	 			elseif (unit == "target") then
  	     				Power.value:SetFormattedText('%s', ShortValue(min))
  	  			else
--	     				Power.value:SetFormattedText('%s|%s', ShortValue(max), ShortValue(min))	
  	     				Power.value:SetFormattedText('%s', ShortValue(min))
	  			end 
			end
		else
			health:SetHeight(sett1ngs.shp+sett1ngs.spower+1)
			Power:Hide()
		end
	end
	if ( sett1ngs.classpower == true ) then
		local _, uclass = UnitClass(unit)
		local color = Power:GetParent().colors.class[uclass]
		if(color) then 
			Power:SetStatusBarColor(color[1], color[2], color[3])
		end
	else
		Power:SetStatusBarColor(unpack(sett1ngs.pcolor))
	end
end
-- Style
local func = function(self, unit)
	self.colors = colors
	self.menu = menu
	self.ignoreHealComm = true

	self:EnableMouse(true)
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
	self:RegisterForClicks"anyup"
	self:SetAttribute("*type2", "menu")
	

	-- Health
	self.Health = CreateFrame("StatusBar", nil, self)
	self.Health:SetStatusBarTexture(sett1ngs.texture)
	self.Health:GetStatusBarTexture():SetHorizTile(false)
	self.Health:SetStatusBarColor(unpack(sett1ngs.hpcolor))
	self.Health:SetFrameStrata("LOW")
	self.Health:SetPoint("LEFT", self)
	self.Health:SetPoint("RIGHT", self)
	self.Health:SetPoint("TOP", self)
	self.Health.bd = SetBD(self.Health, backdrop, sett1ngs.bcolor);
		-- Power spark!
	--local min, max = UnitHealth(unit), UnitHealthMax(unit)
	if (unit == 'player' or unit == 'target' or unit == 'targettarget' or unit == 'focus') then
	self.Health.sparkHP = self.Health:CreateTexture(nil, "OVERLAY")
	self.Health.sparkHP:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	self.Health.sparkHP:SetVertexColor(1, 1, 1, 0.5)
	self.Health.sparkHP:SetBlendMode("ADD")
	self.Health.sparkHP:SetHeight(self.Health:GetHeight())
	self.Health.sparkHP:SetWidth(4)
	end

	self.Health.Smooth = true
	self.Health.frequentUpdates = true
	self.PostUpdateHealth = updateHealth	

	-- Health Text
	local hpp = self.Health:CreateFontString(nil, "OVERLAY")
	hpp:SetFont(sett1ngs.font, sett1ngs.fontsize)
	hpp:SetShadowOffset(1, -1)
	hpp:SetTextColor(1, 1, 1)
	if ( unit ~= "targettarget") then
	  if (unit=="player") then
		if self:GetName() == "oUF_player" then
			hpp:SetPoint("BOTTOM",self, "BOTTOM", 1, sett1ngs.mpower+2)
		end
  	  elseif (unit == "target") then
			hpp:SetPoint("BOTTOM",self, "BOTTOM", -1, sett1ngs.mpower+2)
  	  elseif (unit == "pet") then
		if self:GetName() == "oUF_player" then
			hpp:SetPoint("CENTER",self.Health, 1, 0)
		end
	  end 
	end
	
	self.Health.value = hpp	
	self.Health.PostUpdate = updateHealth
	
	-- Power
	if not(unit == 'targettarget')then
	self.Power = CreateFrame("StatusBar", nil, self)
	if (unit == 'pet' or unit == 'pettarget')then
		self.Power:SetHeight(sett1ngs.spower)
	elseif (unit == 'focus') then
		self.Power:SetHeight(sett1ngs.mpower)
	elseif (unit == 'player' or unit == 'target')then
	   self.Power:SetHeight(sett1ngs.mpower)
	else
	   self.Power:SetHeight(sett1ngs.spower)
	end
	
	self.Power:SetStatusBarTexture(sett1ngs.texture)
	self.Power:GetStatusBarTexture():SetHorizTile(false)
	self.Power:SetStatusBarColor(.25, .25, .35)
	self.Power:SetFrameStrata("LOW")
	self.Power:SetPoint("LEFT", self.Health)
	self.Power:SetPoint("RIGHT", self.Health)
	self.Power:SetPoint("TOP", self.Health, "BOTTOM", 0, -1)	

	self.Power.bd = SetBD(self.Power, backdrop, sett1ngs.bcolor)
	self.Power.Smooth = false
	self.Power.frequentUpdates = true
	self.Power.PostUpdate = updatePower
	  

	-- Power Text
	  local ppp = self.Power:CreateFontString(nil, "OVERLAY")
	  ppp:SetFont(sett1ngs.font, sett1ngs.fontsize)
	  ppp:SetShadowOffset(1, -1)
	  if not(unit == 'pet' or unit == 'pettarget')then
	     if (unit=="player") then
  	        ppp:SetPoint("BOTTOMLEFT",self, "BOTTOMLEFT", 2, sett1ngs.mpower+2)
  	     else
	        ppp:SetPoint("BOTTOMRIGHT",self, "BOTTOMRIGHT", -2, sett1ngs.mpower+2)	
	     end 
	  end   	  
	  ppp:SetTextColor(1, 1, 1)

	  self.Power.value = ppp	  
	  self.Power.PostUpdate = updatePower
	  
	  if unit == "player" then
		-- Power spark!
		local spark = self.Power:CreateTexture(nil, "OVERLAY")
		spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		spark:SetVertexColor(1, 1, 1, 0.5)
		spark:SetBlendMode("ADD")
		spark:SetHeight(self.Power:GetHeight()*2)
		spark:SetWidth(self.Power:GetHeight()*2)
		--  Options and settings
		--spark.rtl = true
		--    Make the spark go from Right To Left instead
		--    Defaults to false
		spark.manatick = true
		--    Show mana regen ticks outside FSR (like the energy ticker)
		--    Defaults to false
		spark.highAlpha = 1
		--    What alpha setting to use for the FSR and energy spark
		--    Defaults to spark:GetAlpha()
		spark.lowAlpha = 0
		--    What alpha setting to use for the mana regen ticker
		--    Defaults to highAlpha / 4
		self.Spark = spark
	end
	end
	if(sett1ngs.castBars)then
		self.Castbar = CreateFrame("StatusBar", nil, self)	  
		self.Castbar:SetStatusBarTexture(sett1ngs.texture)
		self.Castbar:GetStatusBarTexture():SetHorizTile(false)

		self.Castbar.Text = self.Castbar:CreateFontString(nil, "OVERLAY")
		self.Castbar.Text:SetFont(sett1ngs.font, sett1ngs.fontsize)
		self.Castbar.Text:SetShadowOffset(1, -1)
		self.Castbar.Text:SetHeight(sett1ngs.fontsize)
   	-------------  player castbar --------------	
		if( unit == 'player' ) then
			self.Castbar.Text:SetWidth(275)
			self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')		 
			self.Castbar.Time:SetFont(sett1ngs.font, sett1ngs.fontsize)				
			self.Castbar.Time:SetShadowOffset(1, -1)
			self.Castbar.CustomTimeText = function(self, duration)
				if self.casting then
					self.Time:SetFormattedText("%.1f", self.max - duration)
				elseif self.channeling then
					self.Time:SetFormattedText("%.1f", duration)
				end
			end
			if (sett1ngs.playercastbar == 1)then

				self.Castbar:SetStatusBarColor(.3, .3, .3, 1)
				self.Castbar:SetWidth(sett1ngs.cbplayerW)
				self.Castbar:SetHeight(sett1ngs.cbplayerH)
				self.Castbar:SetPoint('CENTER', UIParent, 'BOTTOM', 12, 132)

				self.Castbar.Spark = self.Castbar:CreateTexture(nil, 'OVERLAY')
				self.Castbar.Spark:SetHeight(sett1ngs.cbplayerH+28)
				self.Castbar.Spark:SetWidth(10)
				self.Castbar.Spark:SetBlendMode('ADD')

				self.Castbar.Text:SetPoint("LEFT", self.Castbar, "LEFT", 2, 0)
				self.Castbar.Text:SetJustifyH"LEFT"
				self.Castbar.Time:SetPoint("RIGHT", self.Castbar, "RIGHT",  -2, 0)
				self.Castbar.Button = CreateFrame('Frame', nil, self.Castbar)
				self.Castbar.Button:SetHeight(sett1ngs.cbplayerH)
				self.Castbar.Button:SetWidth(sett1ngs.cbplayerH)
				self.Castbar.Button:SetBackdrop(backdrop)
				self.Castbar.Button:SetBackdropColor(0, 0, 0)
				self.Castbar.Button:SetPoint('RIGHT', self.Castbar, 'LEFT', -3, 0)
				self.Castbar.Button.bd = SetBD(self.Castbar.Button, backdrop, sett1ngs.bcolor)
				self.Castbar.bd = SetBD(self.Castbar, backdrop, sett1ngs.bcolor)

				self.Castbar.Icon = self.Castbar.Button:CreateTexture(nil, 'ARTWORK')
				self.Castbar.Icon:SetAllPoints(self.Castbar.Button)
				self.Castbar.Icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)

				if(sett1ngs.castsafeZone) then
					self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,'BORDER')
					self.Castbar.SafeZone:SetPoint('TOPRIGHT')
					self.Castbar.SafeZone:SetPoint('BOTTOMRIGHT')
					self.Castbar.SafeZone:SetTexture(sett1ngs.texture)
					self.Castbar.SafeZone:SetVertexColor(.69,.31,.31)
				end
			elseif (sett1ngs.playercastbar == 2) then

				self.Castbar:SetToplevel(true)
				self.Castbar:SetStatusBarColor(1, 1, 1, 0.4)
				self.Castbar:SetWidth(sett1ngs.mX)
				self.Castbar:SetHeight(sett1ngs.mhp)
				self.Castbar:SetParent(self.Health) 
				self.Castbar:SetAllPoints('oUF_player')

				self.Castbar.Spark = self.Castbar:CreateTexture(nil, 'OVERLAY')
				self.Castbar.Spark:SetHeight(sett1ngs.mhp+sett1ngs.mpower+28)
				self.Castbar.Spark:SetWidth(10)
				self.Castbar.Spark:SetBlendMode('ADD')

				self.Castbar.Text:SetPoint("BOTTOM", self.Castbar, "TOP", 0, -3)
				self.Castbar.Text:SetJustifyH"CENTER"
				self.Castbar.Time:SetPoint("RIGHT", self.Health, "RIGHT",  -2, 0)
				if(sett1ngs.castsafeZone) then
					self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,'BORDER')
					self.Castbar.SafeZone:SetPoint('TOPRIGHT')
					self.Castbar.SafeZone:SetPoint('BOTTOMRIGHT')
					self.Castbar.SafeZone:SetTexture(sett1ngs.texture)
					self.Castbar.SafeZone:SetVertexColor(.69,.31,.31, 0.4)
				end
			end
	------------- target castbar -----------
		elseif ( unit == 'target' ) then
			self.PostCastStart = castIcon
			self.PostChannelStart = castIcon
			if ((sett1ngs.mhp+sett1ngs.mpower+1) < 24) then
				self.Castbar:SetWidth(213 - 24)
			else
				self.Castbar:SetWidth(213 - (sett1ngs.mhp+sett1ngs.mpower+1))
			end
			self.Castbar:SetHeight(sett1ngs.mhp+sett1ngs.mpower+1)
			self.Castbar:SetStatusBarColor(.3, .3, .3, 1)
			self.Castbar:SetPoint("RIGHT", oUF_target, "LEFT", -3, 0)
			self.Castbar:SetToplevel(false)
			self.Castbar.bd = SetBD(self.Castbar, backdrop, sett1ngs.bcolor)

			self.Castbar.Text:SetWidth(160)
			self.Castbar.Text:SetPoint("LEFT", self.Castbar, "LEFT", 2, 0)
			self.Castbar.Text:SetJustifyH"LEFT"

			self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')		 
			self.Castbar.Time:SetFont(sett1ngs.font, sett1ngs.fontsize)				
			self.Castbar.Time:SetShadowOffset(1, -1)
			self.Castbar.Time:SetPoint("RIGHT", self.Castbar, "RIGHT",  -2, 0)
			self.Castbar.CustomTimeText = function(self, duration)
				if self.casting then
					self.Time:SetFormattedText("%.1f", self.max - duration)
				elseif self.channeling then
					self.Time:SetFormattedText("%.1f", duration)
				end
			end

			self.Castbar.Spark = self.Castbar:CreateTexture(nil, 'OVERLAY')
			self.Castbar.Spark:SetHeight(sett1ngs.mhp+sett1ngs.mpower+28)
			self.Castbar.Spark:SetWidth(10)
			self.Castbar.Spark:SetBlendMode('ADD')

			self.Castbar.Button = CreateFrame('Frame', nil, self.Castbar)
			if (self.Castbar:GetHeight() < 24) then
				self.Castbar.Button:SetHeight(24)
				self.Castbar.Button:SetWidth(24)
			else
				self.Castbar.Button:SetHeight(sett1ngs.mhp+sett1ngs.mpower+1)
				self.Castbar.Button:SetWidth(sett1ngs.mhp+sett1ngs.mpower+1)
			end
			self.Castbar.Button:SetPoint('RIGHT', self.Castbar, 'LEFT', -3, 0)
			self.Castbar.Button.bd = SetBD(self.Castbar.Button, backdrop, sett1ngs.bcolor)

			self.Castbar.Icon = self.Castbar.Button:CreateTexture(nil, 'ARTWORK')
			self.Castbar.Icon:SetAllPoints(self.Castbar.Button)
			self.Castbar.Icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)
	----------- focus castbar -----------------
		elseif ( unit == 'focus' ) then
			self.Castbar:SetStatusBarColor(.3, .3, .3, 1)
			self.Castbar:SetWidth(sett1ngs.sX)
			self.Castbar:SetHeight(sett1ngs.cbfocusH)
			self.Castbar:SetPoint("BOTTOMLEFT", oUF_focus, "TOPLEFT", 0, 3)

			self.Castbar:SetToplevel(false)
			self.Castbar.bd = SetBD(self.Castbar, backdrop, sett1ngs.bcolor)

			self.Castbar.Text:SetWidth(sett1ngs.sX)
			self.Castbar.Text:SetPoint("LEFT", self.Castbar, "LEFT", 2, 0)

			self.Castbar.Spark = self.Castbar:CreateTexture(nil, 'OVERLAY')
			self.Castbar.Spark:SetHeight(sett1ngs.mhp+sett1ngs.mpower+28)
			self.Castbar.Spark:SetWidth(10)
			self.Castbar.Spark:SetBlendMode('ADD')
			
			if (sett1ngs.focusbutton == true) then
			self.Castbar.Button = CreateFrame('Frame', nil, self.Castbar)
			self.Castbar.Button:SetHeight((sett1ngs.mhp+sett1ngs.mpower)+sett1ngs.cbfocusH+4)
			self.Castbar.Button:SetWidth((sett1ngs.mhp+sett1ngs.mpower)+sett1ngs.cbfocusH+4)
			self.Castbar.Button:SetPoint('TOPLEFT', self.Castbar, 'TOPRIGHT', 3, 0)
			self.Castbar.Button.bd = SetBD(self.Castbar.Button, backdrop, sett1ngs.bcolor)
			
			self.Castbar.Icon = self.Castbar.Button:CreateTexture(nil, 'ARTWORK')
			self.Castbar.Icon:SetAllPoints(self.Castbar.Button)
			self.Castbar.Icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)
			end
	------------ pet castbar -------------------
		elseif ( unit == 'pet' and sett1ngs.pcast == true ) then
			self.Castbar:SetStatusBarColor(1, 1, 1, 0.4)
			self.Castbar:SetWidth(sett1ngs.sX-1)
			self.Castbar:SetHeight(sett1ngs.shp+sett1ngs.spower+1)
			self.Castbar:SetAllPoints(oUF_pet)
			self.Castbar:SetParent(self.Health)
			self.Castbar:SetToplevel(true)

			self.Castbar.Text:SetWidth(sett1ngs.sX-10)
			self.Castbar.Text:SetPoint("TOP", self.Castbar, "TOP", 0, 0)

			self.Castbar.Spark = self.Castbar:CreateTexture(nil, 'OVERLAY')
			self.Castbar.Spark:SetHeight(sett1ngs.shp+sett1ngs.spower+25)
			self.Castbar.Spark:SetWidth(10)
			self.Castbar.Spark:SetBlendMode('ADD')
		end
	end	
	-- Leader/MasterLoot Icon
	if(unit == 'player') then
--[[	  local leader = self.Health:CreateTexture(nil, "OVERLAY")
	  leader:SetHeight(16)
	  leader:SetWidth(16)
	  leader:SetPoint("BOTTOMLEFT", self.Health, "TOPLEFT", -5, -8)
	  leader:SetTexture"Interface\\GroupFrame\\UI-Group-LeaderIcon"
	  self.Leader = leader
--]]
	  local masterlooter = self.Health:CreateTexture(nil, 'OVERLAY')
	  masterlooter:SetHeight(16)
	  masterlooter:SetWidth(16)
	  masterlooter:SetPoint('LEFT', leader, 'RIGHT')
	  self.MasterLooter = masterlooter
	end

local UnitPvPUpdate = function(self, event, unit)
	if(unit ~= self.unit) then return end

	local pvp = self.UnitPvP
	if(pvp) then
		local factionGroup = UnitFactionGroup(unit)
		-- FFA!
		if(UnitIsPVPFreeForAll(unit)) then
			pvp:SetStatusBarColor(0, 0, 1)
			pvp:Show()
		elseif(UnitIsPVP(unit) and factionGroup) then
			if(factionGroup == 'Horde') then
				pvp:SetStatusBarColor(1, 0, 0)
			else
				pvp:SetStatusBarColor(0, 1, 0)
			end

			pvp:Show()
		else
			pvp:Hide()
		end
	end
end

	local pvp = CreateFrame("StatusBar", nil, self)
	pvp:SetStatusBarTexture(sett1ngs.texture)
	pvp:SetFrameStrata("MEDIUM")
	pvp:SetFrameLevel(4)
	pvp:SetHeight(sett1ngs.cicon)
	pvp:SetWidth(sett1ngs.cicon)
		if(unit == 'player' or unit == 'focus') then
			pvp:SetPoint("TOPLEFT", self.Health, "TOPLEFT", -1, 1)
		elseif(unit == 'target') then
			pvp:SetPoint("TOPRIGHT", self.Health, "TOPRIGHT", 1, 1)
		end
	pvp.bd = SetBD(pvp, backdrop, sett1ngs.bcolor, "LOW")

	self.UnitPvP = pvp

	self:RegisterEvent("UNIT_FACTION", UnitPvPUpdate)
	table.insert(self.__elements, UnitPvPUpdate)


	if (self:GetParent():GetName()=='oUF_Party') then
		self.LFDRole = self.Health:CreateTexture(nil,'OVERLAY')
		self.LFDRole:SetPoint('BOTTOMLEFT',self.Health,'BOTTOMLEFT')
		self.LFDRole:SetWidth(sett1ngs.mhp/2 + 3)
		self.LFDRole:SetHeight(sett1ngs.mhp/2 + 3)		
		self.LFDRole:SetAlpha(0.4)
	end

	-- Raid Icon
	self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
--	self.RaidIcon:SetPoint('TOP', self, 0, 8)
	if ( unit == 'player' and onlypartyicons == false ) then
		self.RaidIcon:SetPoint("CENTER", self.Health, 0, (sett1ngs.mhp /2))
	elseif ( unit == 'target' or unit == 'targettarget' and onlypartyicons == false ) then
		self.RaidIcon:SetPoint("LEFT", self, "LEFT", 0, 0)
	else
		self.RaidIcon:SetPoint("CENTER", self.Health, 0, (sett1ngs.shp /2))
	end
	self.RaidIcon:SetHeight(16)
	self.RaidIcon:SetWidth(16)
	self.RaidIcon:SetAlpha(0.3)

--[[	local ricon = self.Health:CreateFontString(nil, "OVERLAY")
	ricon:SetFontObject(GameFontNormalSmall)
	ricon:SetTextColor(1, 1, 1, 0.4)
	if (unit == 'player') then
		ricon:SetPoint("CENTER", self.Health, 0, (sett1ngs.mhp /2))
	elseif (unit == 'target') then
		ricon:SetPoint("LEFT", self, "LEFT", 0, 0)
	else
		ricon:SetPoint("CENTER", self.Health, 0, (sett1ngs.shp /2))
	end
	--ricon:SetPoint("CENTER", self, 0, 0)
	ricon:SetHeight(18)
	ricon:SetWidth(18)
	self.RIcon = ricon

	self:RegisterEvent("RAID_TARGET_UPDATE", updateRIcon)
	table.insert(self.__elements, updateRIcon)
--]]	
	if(unit~='player' and unit ~= 'pet')then
	  local name = self.Health:CreateFontString(nil, "OVERLAY")
	  if(unit == "targettarget") then
	      name:SetPoint("CENTER")
	      name:SetFont(sett1ngs.font, sett1ngs.fontsize)
	      name:SetWidth(125)		-- length of the Name
	    elseif(unit == "pettarget") then
	      name:SetPoint("CENTER")
	      name:SetFont(sett1ngs.font, sett1ngs.fontsize)
	      name:SetWidth(98)		-- length of the Name
	    elseif(unit == "focus") then
	      name:SetPoint("LEFT")
	      name:SetFont(sett1ngs.font, sett1ngs.fontsize)
	      name:SetWidth(110)		-- length of the Name
	   else   
	      name:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 4, -(sett1ngs.fontsize / 2))
	      name:SetJustifyH'LEFT'
	      name:SetFont(sett1ngs.font, sett1ngs.fontsize, "OUTLINE")
	      name:SetWidth(sett1ngs.mX)		-- length of the Name
	  end	  
--	  name:SetShadowOffset(1, -1)
 	  name:SetTextColor(1, 1, 1)
	
	  name:SetHeight(sett1ngs.fontsize+2)
	  self.Info = name
	  if(unit == 'target')then
	    self:Tag(self.Info,'[difficulty][level][shortclassification] [raidcolor][name]')
	  else
	    self:Tag(self.Info,'[raidcolor][name]')
	  end
	end 

	-- Buffs and Debuffs
	if(unit == "player") then
		local buffs = CreateFrame("Frame", nil, self)		
		buffs:SetHeight(sett1ngs.buffsize)
		buffs.num = sett1ngs.buffsize
		if ( sett1ngs.pbuffs == 1 ) then
			buffs:SetWidth(300)
			buffs:SetPoint("TOPRIGHT", Minimap, "TOPLEFT", -sett1ngs.pbuffX, -sett1ngs.pbuffY)
		elseif ( sett1ngs.pbuffs == 3 ) then 
			buffs:SetWidth(sett1ngs.mX)
			buffs:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", 0, -((sett1ngs.pbuffY+7)+sett1ngs.auraoffset))
		elseif ( sett1ngs.pbuffs == 2 ) then
			buffs:SetWidth(500)
			buffs:SetPoint("TOPLEFT", UIParent, "TOPLEFT", sett1ngs.pbuffX, -(sett1ngs.pbuffY+3))
			buffs["growth-y"] = "DOWN"
			buffs["growth-x"] = "RIGHT"
			buffs.initialAnchor = "LEFT"
		end
		if not ( sett1ngs.pbuffs == 2 ) then
		buffs["growth-y"] = "DOWN"
		buffs["growth-x"] = "LEFT"
		buffs.initialAnchor = "RIGHT"
		end				
		buffs.size = sett1ngs.buffsize
		buffs.spacing = 3
		buffs.PostCreateIcon = auraIcon
		buffs.PostUpdateIcon = PostUpdateIcon
		self.Buffs = buffs

	    	local debuffs = CreateFrame("Frame", nil, self)
	    	debuffs.size = sett1ngs.buffsize	
	    	debuffs:SetHeight(sett1ngs.buffsize)
	   	debuffs:SetWidth(sett1ngs.mX)
		debuffs:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 7+sett1ngs.auraoffset)
		debuffs["growth-x"] = "LEFT"
		debuffs["growth-y"] = "UP"
		debuffs.initialAnchor = "BOTTOMRIGHT" 	
	    	debuffs.spacing = 3
		debuffs.PostCreateIcon = auraIcon
		debuffs.PostUpdateIcon = PostUpdateIcon	  
	    	self.Debuffs = debuffs 
	end	

	if(unit == 'target') then
		local buffs = CreateFrame("Frame", nil, self)		
		buffs:SetHeight(sett1ngs.buffsize)
		buffs:SetFrameStrata("LOW")
		buffs.num = sett1ngs.buffnum
			if (sett1ngs.tbuffbottom == false) then
				buffs:SetPoint("TOPLEFT", self, "TOPRIGHT", 4.5, 0)
				buffs:SetWidth(sett1ngs.mX)
			else
				buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0, -(7+sett1ngs.auraoffset))
				buffs:SetWidth(sett1ngs.mX)
			end
		buffs["growth-y"] = "DOWN"
		buffs["growth-x"] = "RIGHT"
		buffs.initialAnchor = "LEFT"				
		buffs.size = sett1ngs.buffsize
		buffs.spacing = 3
		if ( sett1ngs.filterbuff == true) then
			buffs.onlyShowPlayer = true	
		end
		buffs.PostCreateIcon = auraIcon
		buffs.PostUpdateIcon = PostUpdateIcon
		self.Buffs = buffs		
		
		local debuffs = CreateFrame("Frame", nil, self)
		debuffs.size = sett1ngs.buffsize
		debuffs:SetHeight(sett1ngs.buffsize)
		debuffs:SetWidth(sett1ngs.mX)
		debuffs:SetFrameStrata("LOW")
		debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 7+sett1ngs.auraoffset)
		debuffs["growth-x"] = "RIGHT"
		debuffs.num = sett1ngs.debuffnum
		debuffs["growth-y"] = "UP"
		debuffs.initialAnchor = "BOTTOMLEFT" 
		debuffs.PostCreateIcon = auraIcon
		debuffs.PostUpdateIcon = PostUpdateIcon	
		if ( sett1ngs.filterdebuff == true) then
			debuffs.onlyShowPlayer = true	
		end
	    debuffs.spacing = 3	  
	    self.Debuffs = debuffs 
	   
	end

	if(unit == 'focus') then
		--if not( sett1ngs.faura == 0) then
			--if ( sett1ngs.faura == 1 or sett1ngs.faura == 2 or sett1ngs.faura == 3) then
				local debuffs = CreateFrame("Frame", nil, self)
				debuffs.size = sett1ngs.buffsize
				debuffs:SetHeight(sett1ngs.buffsize)
				debuffs:SetWidth(100)
				debuffs:SetPoint('BOTTOMRIGHT', oUF_focus, 'BOTTOMLEFT', -4, 0)
				debuffs["growth-x"] = "LEFT"
				debuffs["growth-y"] = "UP"
				debuffs.initialAnchor = "BOTTOMRIGHT" 		
				debuffs.spacing = 3
				if ( sett1ngs.faura == 1 ) then
	    				debuffs.CustomFilter = focusdebuffFilter
				elseif ( sett1ngs.faura == 2 ) then
					debuffs.onlyShowPlayer = true
				end
				debuffs.PostCreateIcon = auraIcon
				debuffs.PostUpdateIcon = PostUpdateIcon	
	    			self.Debuffs = debuffs
		--	end
	    	--end
	end

	-- Combo Points
	if(unit == 'target') then
		self.CPoints = self:CreateFontString(nil, 'OVERLAY')
		self.CPoints:SetFont(sett1ngs.font, sett1ngs.fontsize+14)
		self.CPoints:SetShadowOffset(1, -1)
		self.CPoints:SetPoint("CENTER", UIParent, 0, 0)
		self.CPoints:SetTextColor(.8, .8, 0)		
		self.CPoints.unit = 'player' or 'pet' or "Vehicle"
	end
		
--[[	if(unit == 'player' and UnitLevel('player') ~= MAX_PLAYER_LEVEL) then
		self.Resting = self.Power:CreateTexture(nil, 'OVERLAY')
		self.Resting:SetHeight(25)
		self.Resting:SetWidth(27)
		self.Resting:SetPoint('RIGHT', -15, 13)
		self.Resting:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
		self.Resting:SetTexCoord(0,0.5,0,0.421875)
	end
--]]
    --[[ Combat icon ]]
    if(unit == 'player') then
	self.Combat = CreateFrame("StatusBar", nil, self)
	self.Combat:SetStatusBarTexture(sett1ngs.texture)
	self.Combat:SetStatusBarColor(1, 0, 0)
	self.Combat:SetFrameStrata("HIGH")
	self.Combat:SetHeight(sett1ngs.cicon)
	self.Combat:SetWidth(sett1ngs.cicon)
	self.Combat:SetPoint("TOPRIGHT", self, "TOPRIGHT", 1, 1)
	self.Combat.bd = SetBD(self.Combat, backdrop, sett1ngs.bcolor, "MEDIUM")
    end



	-- DebuffHidghtlight
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlightFilter = true

	if(unit == 'player') then		
		if ( sett1ngs.dkrunes == true and class == 'DEATHKNIGHT') then
			local runes = CreateFrame("Frame", nil, self)
			runes:SetHeight(sett1ngs.panelsH)
			runes:SetWidth(sett1ngs.mX)
			runes.spacing = 1
			runes.anchor = "TOPLEFT"
			runes.growth = "RIGHT"
			runes.height = sett1ngs.panelsH
			runes.width = (sett1ngs.mX-5) / 6 
			runes.order = { 1, 2, 3, 4, 5, 6 }
			runes:SetPoint('BOTTOM', self.Health, 'TOP', 0, 4)

			for i = 1, 6 do
				local bar = CreateFrame("StatusBar", nil, self)
				bar:SetHeight(sett1ngs.panelsH)
				bar:SetWidth((sett1ngs.mX-5) / 6)
				bar:SetStatusBarTexture(sett1ngs.texture)
				if (i == 1) then
					bar:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 1)
				else
					bar:SetPoint("TOPLEFT", runes[i-1], "TOPRIGHT", 1, 0)
				end
				bar:GetStatusBarTexture():SetHorizTile(false)
				bar:SetFrameStrata("BACKGROUND")
				bar:SetFrameLevel(2)
				bar.bd = SetBD(bar, backdrop, sett1ngs.bcolor, "BACKGROUND")
				runes[i] = bar
			end
			self.Runes = runes
		end
		-- Experience
		if(IsAddOnLoaded('oUF_Experience')) then
			self.Experience = CreateFrame('StatusBar', nil, self)
			self.Experience:SetPoint('TOP', self, 'BOTTOM', 0, -1)
			self.Experience:SetStatusBarTexture(sett1ngs.texture)
			self.Experience:GetStatusBarTexture():SetHorizTile(false)
			self.Experience:SetStatusBarColor(0,.7,1)
			self.Experience:SetHeight(3)
			self.Experience:SetWidth(sett1ngs.mX)
            		self.Experience.MouseOver = true
			self.Experience.Tooltip = true
			self.Experience:SetAlpha(0)
			self.Experience.bd = SetBD(self.Experience, backdrop, sett1ngs.bcolor)
			self.Experience:SetScript ('OnEnter', function(self) self:SetAlpha(1) end)
			self.Experience:SetScript ('OnLeave', function(self) self:SetAlpha(0) end)

		end
		
		if IsAddOnLoaded("oUF_WeaponEnchant") then
			self.Enchant = CreateFrame("Frame", nil, self)
			self.Enchant.size = sett1ngs.buffsize
			self.Enchant:SetHeight(self.Enchant.size * 1)
			self.Enchant:SetWidth(self.Enchant.size * 2)
			self.Enchant:SetPoint("TOPRIGHT", oUF_player, "TOPLEFT", -3, 0)
			self.Enchant["growth-x"] = "LEFT"
			self.Enchant.spacing = 3
			self.Enchant.initialAnchor = "RIGHT"
			self.PostCreateEnchantIcon = auraIcon
			self.PostUpdateEnchantIcons = CreateEnchantTimer
		end

		-- Reputation
		if(IsAddOnLoaded('oUF_Reputation') and UnitLevel('player') == MAX_PLAYER_LEVEL) then
			self.Reputation = CreateFrame('StatusBar', nil, self)
			self.Reputation:SetPoint('TOP', self, 'BOTTOM', 0, -1)
			self.Reputation:SetStatusBarTexture(sett1ngs.texture)
			self.Reputation:GetStatusBarTexture():SetHorizTile(false)
			self.Reputation:SetHeight(3)
			self.Reputation:SetWidth(sett1ngs.mX)
			self.Reputation:SetAlpha(0)
			local r, g, b
			local class = select(2, UnitClass('player'))
			if class then
				r = RAID_CLASS_COLORS[class].r
				g = RAID_CLASS_COLORS[class].g
				b = RAID_CLASS_COLORS[class].b
			end
			self.Reputation:SetStatusBarColor(r, g, b)
    			self.Reputation.MouseOver = true			
			self.Reputation.Tooltip = true

			self.Reputation.bd = SetBD(self.Reputation, backdrop, sett1ngs.bcolor)

			self.Reputation:SetScript ('OnEnter', function(self) self:SetAlpha(1) end)
			self.Reputation:SetScript ('OnLeave', function(self) self:SetAlpha(0) end)
		end
		
		if(class == 'DRUID') then
			self.DruidPower = CreateFrame('StatusBar', nil, self)
			self.DruidPower:SetPoint('TOP', self.Health, 'TOP', 0, 4)
			self.DruidPower:SetStatusBarTexture(sett1ngs.texture)
			self.DruidPower:GetStatusBarTexture():SetHorizTile(false)
			self.DruidPower:SetHeight(sett1ngs.panelsH)
			self.DruidPower:SetWidth(sett1ngs.mX)
			self.DruidPower:SetAlpha(0)
			self.DruidPower.bd = SetBD(self.DruidPower, backdrop, sett1ngs.bcolor)

			self.DruidPower.Text = self.DruidPower:CreateFontString(nil, 'OVERLAY')
			self.DruidPower.Text:SetFont(sett1ngs.font, sett1ngs.fontsize, 'outline')
			self.DruidPower.Text:SetPoint('CENTER', self.DruidPower, 0, 1)
		--	self.DruidPower.Text:SetTextColor(unpack(colors.power['MANA']))

			self:RegisterEvent('UNIT_MANA', UpdateDruidPower)
			self:RegisterEvent('UNIT_ENERGY', UpdateDruidPower)
			self:RegisterEvent('PLAYER_LOGIN', UpdateDruidPower)
		end

		if (IsAddOnLoaded("oUF_TotemBar") and class=="SHAMAN" and unit=="player") then
			self.TotemBar = {}
			for i = 1, 4 do
				self.TotemBar[i] = CreateFrame("StatusBar", self:GetName().."_TotemBar"..i, self)
				if (i == 1) then
					self.TotemBar[i]:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 1)
				else
					self.TotemBar[i]:SetPoint("TOPLEFT", self.TotemBar[i-1], "TOPRIGHT", 1, 0)
				end
				self.TotemBar[i]:SetStatusBarTexture(sett1ngs.texture)
				self.TotemBar[i]:GetStatusBarTexture():SetHorizTile(false)
				self.TotemBar[i]:SetHeight(3)
				self.TotemBar[i]:SetWidth((sett1ngs.mX-3)/4)
				self.TotemBar[i].destroy = true
				self.TotemBar[i]:SetMinMaxValues(0, 1)
				self.TotemBar[i].bg = SetBD(self.TotemBar[i], backdrop, sett1ngs.bcolor)
			end
		end
	end

	-- CombatFeedback 
	if not (unit == "player")then
	  local cbft = self.Health:CreateFontString(nil, "OVERLAY")
	  cbft:SetPoint("CENTER", self)
	  cbft:SetFont(sett1ngs.font, sett1ngs.fontsize)
	  cbft:SetShadowOffset(1, -1)
	  self.CombatFeedbackText = cbft
	  self.CombatFeedbackText.maxAlpha = 1
	end

	if(not unit) then
		self.Range = true
		self.inRangeAlpha = 1
		self.outsideRangeAlpha = .5
	end
	
	if(unit == "targettarget") then 
	  self:SetAttribute('initial-height', sett1ngs.shp+sett1ngs.spower+1)
	  self:SetAttribute('initial-width', sett1ngs.sX)
	elseif (unit == "pet" or unit == "pettarget") then
		self:SetAttribute('initial-height', sett1ngs.shp+sett1ngs.spower+1)
	       	self:SetAttribute('initial-width', sett1ngs.sX)
	elseif (unit == "focus") then
		self:SetAttribute('initial-height', sett1ngs.mhp+sett1ngs.mpower+1)
		self:SetAttribute('initial-width', sett1ngs.sX)
	elseif (unit == "player" or unit == "target") then
		self:SetAttribute('initial-height', sett1ngs.mhp+sett1ngs.mpower+1)
		self:SetAttribute('initial-width', sett1ngs.mX)
	end
if (unit == 'target') then
	self.CPoints = {}
		for id = 1, MAX_COMBO_POINTS do
			self.CPoints[id] = CreateFrame('StatusBar', nil, self)

			if (id > 1) then
				self.CPoints[id]:SetPoint('TOPLEFT', self.CPoints[id-1], 'TOPRIGHT', 1, 0)
			else
				self.CPoints[id]:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', 0, -1)
			end

			self.CPoints[id]:SetStatusBarTexture(sett1ngs.texture)
			self.CPoints[id]:GetStatusBarTexture():SetHorizTile(false)
			local r, g, b
			local class = select(2, UnitClass('player'))
			if class then
				r = RAID_CLASS_COLORS[class].r
				g = RAID_CLASS_COLORS[class].g
				b = RAID_CLASS_COLORS[class].b
			end
			self.CPoints[id]:SetStatusBarColor(r, g, b, 1)
			self.CPoints[id].bd = SetBD(self.CPoints[id], backdrop, sett1ngs.bcolor)
			self.CPoints[id]:SetHeight(sett1ngs.panelsH)
			self.CPoints[id]:SetWidth((sett1ngs.mX-4) / MAX_COMBO_POINTS)
		end

		self.CPoints.unit = PlayerFrame.unit
		self:RegisterEvent('UNIT_COMBO_POINTS', updateCombo)
	end
	
	if ( sett1ngs.swapV == true ) then  
		self.disallowVehicleSwap = false
	else
		self.disallowVehicleSwap = true
	end
	return self
end

oUF:RegisterStyle("korn3r", func)

oUF:SetActiveStyle"korn3r"
local player = oUF:Spawn('player', 'oUF_player'):SetPoint('BOTTOMRIGHT', UIParent, 'BOTTOM', -111, sett1ngs.offsetmY) --   
local target = oUF:Spawn('target', 'oUF_target'):SetPoint('BOTTOMLEFT', UIParent, 'BOTTOM', 111, sett1ngs.offsetmY) -- ... 
local tot = oUF:Spawn('targettarget', 'oUF_tot'):SetPoint('TOPRIGHT', oUF_target, 'BOTTOMLEFT', -(111 - ((sett1ngs.sX-1)/2) ), -3)-- ... tot
local focus = oUF:Spawn('focus', 'oUF_focus'):SetPoint('BOTTOMLEFT', oUF_player, 'TOPLEFT', 0, sett1ngs.buffsize+10) -- ... 
local pet = oUF:Spawn('pet', 'oUF_pet'):SetPoint('TOP', oUF_tot, 'BOTTOM', 0, -24) --   
if (sett1ngs.showptarget == true)then
local pettarget = oUF:Spawn('pettarget', 'oUF_pettarget'):SetPoint('TOP', oUF_pet, 'BOTTOM', 0, -3) --   
end